--- crash-5.1.0.orig/extensions/sial.c	2010-12-01 06:58:02.000000000 +1100
+++ crash-5.1.0/extensions/sial.c	2011-01-17 19:14:30.272418645 +1100
@@ -170,7 +170,16 @@
         type=sym->type;
         if(sial_is_typedef(ctype) && v) goto match;
         switch(TYPE_CODE(type)) {
-            case TYPE_CODE_TYPEDEF: case TYPE_CODE_INT: 
+	    case TYPE_CODE_INT: 
+                sial_dbg_named(DBG_TYPE, name, 2, "Variable is integer\n");
+		if (sial_is_typedef(ctype)) {
+		    sial_dbg_named(DBG_TYPE, name, 2, 
+				    "integer is not a typedef\n");
+		    break;
+			
+		}
+	
+            case TYPE_CODE_TYPEDEF:
                                     if(sial_is_typedef(ctype))  goto match; break;
             case TYPE_CODE_ENUM:    if(sial_is_enum(ctype))     goto match; break;
             case TYPE_CODE_STRUCT:  if(sial_is_struct(ctype))   goto match; break;